package cn.superdesk.uniorder.common.security.superdeskapp.sign;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Arrays;
import java.util.UUID;

/**
 * 服务之窗1L- ApiEnCrypUtils
 * 生成app_key 和 app_secret
 *
 * @Description TODO
 * @author: jiangyong
 * @since: 2020/9/18 9:47
 */
public class OpenDataApiAppUtils {
	private final static String[] chars = new String[]{"a", "b", "c", "d", "e", "f",
			"g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s",
			"t", "u", "v", "w", "x", "y", "z", "0", "1", "2", "3", "4", "5",
			"6", "7", "8", "9", "A", "B", "C", "D", "E", "F", "G", "H", "I",
			"J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V",
			"W", "X", "Y", "Z"};

	/**
	 * 生成appkey
	 * 本算法利用62个可打印字符,通过随机生成32位UUID,由于UUID都为十六进制,
	 * 所以将UUID分成16组,每2个为一组,然后通过模62操作,结果作为索引取出字符
	 *
	 * @return
	 */
	public static String getAppKey() {
		StringBuffer shortBuffer = new StringBuffer();
		shortBuffer.append("fwzc");
		String uuid = UUID.randomUUID().toString().replace("-", "");
		for (int i = 0; i < 16; i++) {
			String str = uuid.substring(i * 2, i * 2 + 2);
			int    x   = Integer.parseInt(str, 16);
			shortBuffer.append(chars[x % 0x3E]);
		}

		return shortBuffer.toString();
	}

	public static void main(String[] args) {
		String appkey = getAppKey();
		System.out.println(appkey);
		System.out.println(getAppSecret(appkey, "简讯"));
	}

	/**
	 * 生成app_secret
	 *
	 * @param appId
	 * @param appName
	 * @return
	 */
	public static String getAppSecret(String appId, String appName) {
		try {
			String[]     array = new String[]{appId, appName};
			StringBuffer sb    = new StringBuffer();
			// 字符串排序
			Arrays.sort(array);
			for (int i = 0; i < array.length; i++) {
				sb.append(array[i]);
			}
			String        str = sb.toString();
			MessageDigest md  = MessageDigest.getInstance("SHA-1");
			md.update(str.getBytes());
			byte[] digest = md.digest();

			StringBuffer hexstr = new StringBuffer();
			String       shaHex;
			for (int i = 0; i < digest.length; i++) {
				shaHex = Integer.toHexString(digest[i] & 0xFF);
				if (shaHex.length() < 2) {
					hexstr.append(0);
				}
				hexstr.append(shaHex);
			}
			return hexstr.toString();
		} catch (NoSuchAlgorithmException e) {
			e.printStackTrace();
			throw new RuntimeException();
		}
	}

}
